#include <stdio.h>
#include <stdbool.h>
#include "time.h"

static bool checkTime(struct time);

/********************************************************************
 * Richiede di inserire un istante temporale e restitiusce la 
 * corrispondente struttura. Se l'istante inserito non e' corretto 
 * viene richiesto nuovamente.
 ********************************************************************/
struct time insertTime(void) {
	int hour, minutes, seconds;
	struct time t;
	bool end = false;

	while (!end) { 
		printf("Inserire un istante temporale nel formato h:m:s.\n");
		scanf("%i:%i:%i", &hour, &minutes, &seconds);
		t.hour = hour;
		t.minutes = minutes;
		t.seconds = seconds;
		end = checkTime(t);
	if (!end)
		printf("L'istante temporale non e' valido.\n");
 	}
  
  return t; 
}


/********************************************************************
 * Verifica se l'istante temporale e' corretto.
 ********************************************************************/
static bool checkTime(struct time t) {
	int n;

	// secondi compresi tra 0 e 59
	if (t.seconds < 0 || t.seconds > 59)
		return false;

	// minuti compresi tra 0 e 59
	if (t.minutes < 0 || t.minutes > 59)
		return false;

	// minuti > 0 e < 23
	if (t.hour < 0 || t.hour > 23)
		return false;
 
	return true;
}


/********************************************************************
 * Calcola la differenza tra due istanti temporali
 ********************************************************************/
struct time elapsedTime(struct time t1, struct time t2) {

	// istante t1 espresso in secondi
	int n1 = t1.seconds + t1.minutes * 60 + t1.hour * 60 * 60;
	// istante t2 espresso in secondi
	int n2 = t2.seconds + t2.minutes * 60 + t2.hour * 60 * 60;
	// differenza in secondi   
	int diff = n2 - n1;   
	// rappresentano la conversione di diff nel formato h:m:s
	int h, m, s;

	s = diff % 60;
	diff = diff / 60; 
	m = diff % 60;
	h = diff / 60;

	return (struct time) {h, m, s}; // crea la struttura e la restituisce
}
