#include <stdio.h>
#include <stdbool.h>
#include "punto.h"

static bool in_regione(struct punto);

/********************************************************************
 * Chiede di inserire un punto e restituisce la corrispondente 
 * struttura. Se il punto e' fuori dalla regione di piano ammissibile, 
 * lo chiede di nuovo.
 ********************************************************************/
struct punto inserisci_punto(void) {
	struct punto p;
  
	do {
		printf("Inserire l'ascissa  (valore compreso tra 0 e %i): ", DIM - 1);
		scanf("%d", &p.ascissa);
		printf("Inserire l'ordinata (valore compreso tra 0 e %i): ", DIM - 1);
		scanf("%d", &p.ordinata);
		if (!in_regione(p)) 
			printf("Punto fuori dalla regione ammissibile, riprovare\n");
	} while (!in_regione(p));
	
	return p;
}

static bool in_regione(struct punto p) {
	if (p.ascissa >= 0 && p.ascissa < DIM &&
		p.ordinata >= 0 && p.ordinata < DIM)
		return true;
	return false;
}

